# ASN.1 module DENM-PDU-Description
 OID: _{itu-t (0) identified-organization (4) etsi (0) itsDomain (5) wg1 (1) denmPduRelease2 (103831) major-version-1 (1) minor-version-1 (1)}_

## Imports:
 * **[ETSI-ITS-CDD](ETSI-ITS-CDD.md)** *{itu-t (0) identified-organization (4) etsi (0) itsDomain (5) wg1 (1) ts (102894) cdd (2) major-version-3 (3) minor-version-1 (1)}*<br/>
  
## Data Elements:
### <a name="DENM"></a>DENM

Fields:
* header [**ItsPduHeader**](ETSI-ITS-CDD.md#ItsPduHeader)  (WITH COMPONENTS {... , protocolVersion (2)<br>
* denm [**DenmPayload**](#DenmPayload) <br>
    messageId(denm)}),
```asn1
DENM ::= SEQUENCE {
	header ItsPduHeader (WITH COMPONENTS {... , protocolVersion (2), messageId(denm)}),
	denm   DenmPayload
}
```

### <a name="DenmPayload"></a>DenmPayload

Fields:
* management [**ManagementContainer**](#ManagementContainer) <br>
* situation [**SituationContainer**](#SituationContainer)  OPTIONAL<br>
   
* location [**LocationContainer**](#LocationContainer)  OPTIONAL<br>
   
* alacarte [**AlacarteContainer**](#AlacarteContainer)  OPTIONAL<br>
   
```asn1
DenmPayload ::= SEQUENCE {
	management ManagementContainer,
	situation  SituationContainer OPTIONAL,
	location   LocationContainer OPTIONAL,
	alacarte   AlacarteContainer OPTIONAL
}
```

### <a name="ManagementContainer"></a>ManagementContainer

Fields:
* actionID [**ActionID**](ETSI-ITS-CDD.md#ActionID) <br>
* detectionTime [**TimestampIts**](ETSI-ITS-CDD.md#TimestampIts) <br>
   
* referenceTime [**TimestampIts**](ETSI-ITS-CDD.md#TimestampIts) <br>
   
* termination [**Termination**](#Termination)  OPTIONAL<br>
   
* eventPosition [**ReferencePosition**](ETSI-ITS-CDD.md#ReferencePosition) <br>
   
* awarenessDistance [**StandardLength3b**](ETSI-ITS-CDD.md#StandardLength3b)  OPTIONAL<br>
   
* awarenessTrafficDirection [**TrafficDirection**](ETSI-ITS-CDD.md#TrafficDirection)  OPTIONAL<br>
   
* validityDuration [**DeltaTimeSecond**](ETSI-ITS-CDD.md#DeltaTimeSecond)  DEFAULT defaultValidity<br>
   
* transmissionInterval [**DeltaTimeMilliSecondPos**](ETSI-ITS-CDD.md#DeltaTimeMilliSecondPos)  OPTIONAL<br>
    
* stationType [**StationType**](ETSI-ITS-CDD.md#StationType) <br>
   
```asn1
ManagementContainer ::= SEQUENCE {
	actionID                  ActionID,
	detectionTime             TimestampIts,
	referenceTime             TimestampIts,
	termination               Termination OPTIONAL,
	eventPosition             ReferencePosition,
	awarenessDistance         StandardLength3b OPTIONAL,
	awarenessTrafficDirection TrafficDirection OPTIONAL,
	validityDuration          DeltaTimeSecond DEFAULT defaultValidity, 
	transmissionInterval      DeltaTimeMilliSecondPos OPTIONAL,
	stationType               StationType,
	...
}
```

### <a name="SituationContainer"></a>SituationContainer

Fields:
* informationQuality [**InformationQuality**](ETSI-ITS-CDD.md#InformationQuality) <br>
* eventType [**CauseCodeV2**](ETSI-ITS-CDD.md#CauseCodeV2) <br>
   
* linkedCause [**CauseCodeV2**](ETSI-ITS-CDD.md#CauseCodeV2)  OPTIONAL<br>
   
* eventZone [**EventZone**](ETSI-ITS-CDD.md#EventZone)  OPTIONAL<br>
   
```asn1
SituationContainer ::= SEQUENCE {
	informationQuality InformationQuality,
	eventType          CauseCodeV2,
	linkedCause        CauseCodeV2 OPTIONAL,
	eventZone          EventZone OPTIONAL,
	...
}
```

### <a name="LocationContainer"></a>LocationContainer

Fields:
* eventSpeed [**Speed**](ETSI-ITS-CDD.md#Speed)  OPTIONAL<br>
* eventPositionHeading [**Wgs84Angle**](ETSI-ITS-CDD.md#Wgs84Angle)  OPTIONAL<br>
   
* traces [**Traces**](ETSI-ITS-CDD.md#Traces) <br>
   
* roadType [**RoadType**](ETSI-ITS-CDD.md#RoadType)  OPTIONAL<br>
   
```asn1
LocationContainer ::= SEQUENCE {
	eventSpeed           Speed OPTIONAL,
	eventPositionHeading Wgs84Angle OPTIONAL,
	traces               Traces,
	roadType             RoadType OPTIONAL,
	...
}
```

### <a name="ImpactReductionContainer"></a>ImpactReductionContainer

Fields:
* heightLonCarrLeft [**HeightLonCarr**](ETSI-ITS-CDD.md#HeightLonCarr) <br>
* heightLonCarrRight [**HeightLonCarr**](ETSI-ITS-CDD.md#HeightLonCarr) <br>
   
* posLonCarrLeft [**PosLonCarr**](ETSI-ITS-CDD.md#PosLonCarr) <br>
   
* posLonCarrRight [**PosLonCarr**](ETSI-ITS-CDD.md#PosLonCarr) <br>
   
* positionOfPillars [**PositionOfPillars**](ETSI-ITS-CDD.md#PositionOfPillars) <br>
   
* posCentMass [**PosCentMass**](ETSI-ITS-CDD.md#PosCentMass) <br>
   
* wheelBaseVehicle [**WheelBaseVehicle**](ETSI-ITS-CDD.md#WheelBaseVehicle) <br>
   
* turningRadius [**TurningRadius**](ETSI-ITS-CDD.md#TurningRadius) <br>
   
* posFrontAx [**PosFrontAx**](ETSI-ITS-CDD.md#PosFrontAx) <br>
   
* positionOfOccupants [**PositionOfOccupants**](ETSI-ITS-CDD.md#PositionOfOccupants) <br>
   
* vehicleMass [**VehicleMass**](ETSI-ITS-CDD.md#VehicleMass) <br>
   
* requestResponseIndication [**RequestResponseIndication**](ETSI-ITS-CDD.md#RequestResponseIndication) <br>
   
```asn1
ImpactReductionContainer ::= SEQUENCE {
	heightLonCarrLeft         HeightLonCarr,
	heightLonCarrRight        HeightLonCarr,
	posLonCarrLeft            PosLonCarr,
	posLonCarrRight           PosLonCarr,
	positionOfPillars         PositionOfPillars,
	posCentMass               PosCentMass,
	wheelBaseVehicle          WheelBaseVehicle,
	turningRadius             TurningRadius,
	posFrontAx                PosFrontAx,
	positionOfOccupants       PositionOfOccupants,
	vehicleMass               VehicleMass,
	requestResponseIndication RequestResponseIndication
}
```

### <a name="RoadWorksContainerExtended"></a>RoadWorksContainerExtended

Fields:
* lightBarSirenInUse [**LightBarSirenInUse**](ETSI-ITS-CDD.md#LightBarSirenInUse)  OPTIONAL<br>
* closedLanes [**ClosedLanes**](ETSI-ITS-CDD.md#ClosedLanes)  OPTIONAL<br>
   
* restriction [**RestrictedTypes**](ETSI-ITS-CDD.md#RestrictedTypes)  OPTIONAL<br>
   
* speedLimit [**SpeedLimit**](ETSI-ITS-CDD.md#SpeedLimit)  OPTIONAL<br>
   
* incidentIndication [**CauseCodeV2**](ETSI-ITS-CDD.md#CauseCodeV2)  OPTIONAL<br>
   
* recommendedPath [**ItineraryPath**](ETSI-ITS-CDD.md#ItineraryPath)  OPTIONAL<br>
   
* startingPointSpeedLimit [**DeltaReferencePosition**](ETSI-ITS-CDD.md#DeltaReferencePosition)  OPTIONAL<br>
   
* trafficFlowRule [**TrafficRule**](ETSI-ITS-CDD.md#TrafficRule)  OPTIONAL<br>
   
* referenceDenms [**ActionIdList**](ETSI-ITS-CDD.md#ActionIdList)  OPTIONAL<br>
   
```asn1
RoadWorksContainerExtended ::= SEQUENCE {
	lightBarSirenInUse      LightBarSirenInUse OPTIONAL,
	closedLanes             ClosedLanes OPTIONAL,
	restriction             RestrictedTypes OPTIONAL,
	speedLimit              SpeedLimit OPTIONAL,
	incidentIndication      CauseCodeV2 OPTIONAL,
	recommendedPath         ItineraryPath OPTIONAL,
	startingPointSpeedLimit DeltaReferencePosition OPTIONAL,
	trafficFlowRule         TrafficRule OPTIONAL,
	referenceDenms          ActionIdList OPTIONAL
 }
```

### <a name="StationaryVehicleContainer"></a>StationaryVehicleContainer

Fields:
* stationarySince [**StationarySince**](ETSI-ITS-CDD.md#StationarySince)  OPTIONAL<br>
* stationaryCause [**CauseCodeV2**](ETSI-ITS-CDD.md#CauseCodeV2)  OPTIONAL<br>
    
* carryingDangerousGoods [**DangerousGoodsExtended**](ETSI-ITS-CDD.md#DangerousGoodsExtended)  OPTIONAL<br>
   
* numberOfOccupants [**NumberOfOccupants**](ETSI-ITS-CDD.md#NumberOfOccupants)  OPTIONAL<br>
   
* vehicleIdentification [**VehicleIdentification**](ETSI-ITS-CDD.md#VehicleIdentification)  OPTIONAL<br>
   
* energyStorageType [**EnergyStorageType**](ETSI-ITS-CDD.md#EnergyStorageType)  OPTIONAL<br>
   
```asn1
StationaryVehicleContainer ::= SEQUENCE {
	stationarySince        StationarySince OPTIONAL, 
	stationaryCause        CauseCodeV2 OPTIONAL,
	carryingDangerousGoods DangerousGoodsExtended OPTIONAL,
	numberOfOccupants      NumberOfOccupants OPTIONAL,
	vehicleIdentification  VehicleIdentification OPTIONAL,
	energyStorageType      EnergyStorageType OPTIONAL
}
```

### <a name="AlacarteContainer"></a>AlacarteContainer

Fields:
* lanePosition [**LanePosition**](ETSI-ITS-CDD.md#LanePosition)  OPTIONAL<br>
* impactReduction [**ImpactReductionContainer**](#ImpactReductionContainer)  OPTIONAL<br>
   
* externalTemperature [**Temperature**](ETSI-ITS-CDD.md#Temperature)  OPTIONAL<br>
   
* roadWorks [**RoadWorksContainerExtended**](#RoadWorksContainerExtended)  OPTIONAL<br>
   
* positioningSolution [**PositioningSolutionType**](ETSI-ITS-CDD.md#PositioningSolutionType)  OPTIONAL<br>
   
* stationaryVehicle [**StationaryVehicleContainer**](#StationaryVehicleContainer)  OPTIONAL<br>
   
```asn1
AlacarteContainer ::= SEQUENCE {
	lanePosition        LanePosition OPTIONAL,
	impactReduction     ImpactReductionContainer OPTIONAL,
	externalTemperature Temperature OPTIONAL,
	roadWorks           RoadWorksContainerExtended OPTIONAL,
	positioningSolution PositioningSolutionType OPTIONAL,
	stationaryVehicle   StationaryVehicleContainer OPTIONAL,
	...
}
```

```asn1
defaultValidity INTEGER ::= 600
```


### <a name="Termination"></a>Termination
```asn1
Termination ::= ENUMERATED {isCancellation(0), isNegation (1)}
```



